/*

                           e Y8b    Y8b YV4.08P888 88e
                          d8b Y8b    Y8b Y888P 888 888D
                         d888b Y8b    Y8b Y8P  888 88"
                        d8WuHan888b    Y8b Y   888 b,
                       d8888888b Y8b    Y8P    888 88b,
           8888 8888       ,e,                                  888
           8888 888820088e  " Y8b Y888P ,e e, 888,8, dP"Y ,"Y88b888
           8888 8888888 88b888 Y8b Y8P d88 88b888 " C88b "8" 888888
           8888 8888888 888888  Y8b "  888   ,888    Y88D,ee 888888
           'Y88 88P'888 888888   Y8P    "YeeP"888   d,dP "88 888888
   888 88b,                    d8  888                     888
   888 88P' e88 88e  e88 88e  d88  888 e88 88e  ,"Y88b e88 888 ,e e, 888,8,
   888 8K  d888 888bd888 8Shaoziyang88d888 888b"8" 888d888 888d88 88b888 "
   888 88b,Y888 888PY888 888P 888  888Y888 888P,ee 888Y888 888888   ,888
   888 88P' "88 88"  "88 88"  888  888 "88 88" "88 888 "88 888 "YeeP"888


  Project:       AVR Universal BootLoader
  File:          bootcfg.h
                 user's configuration.
  Version:       4.5

  Compiler:      WinAVR20071221 + AVR Studio 4.14 b589

  Author:        Shaoziyang
                 Shaoziyang@gmail.com
                 http://avrubd.googlepages.com
                 http://groups.google.com/group/avrub?hl=en

  Date:          2008.8
  Made by:       AVRUBD autocode, 27.10.2011 13:27:55

  See readme.htm to get more information.

*/

#ifndef _BOOTCFG_H_
#define _BOOTCFG_H_        1


//enable decrypt buffer
#define Decrypt            1

//crypt algorithm
//PC1_128, PC1 Cipher Algorithm with 128 bits key
#define PC1_128            1
//PC1_256, PC1 Cipher Algorithm with 256 bits key
#define PC1_256            2
//AES_128, AES Cipher Algorithm with 128 bits key
#define AES_128            3
//AES_256, AES Cipher Algorithm with 256 bits key
#define AES_256            4

#define Algorithm          AES_128

#if Decrypt

#if (Algorithm == PC1_128) || (Algorithm == AES_128)
//Define decrypt key: 128b
unsigned char DecryptKey[16] ={
  0x46, 0xCC, 0x2B, 0xCA, 0x8A, 0x48, 0x1A, 0x8D,
  0xE3, 0xFA, 0x71, 0xDB, 0x9F, 0xF4, 0xEB, 0xD3
};
#elif (Algorithm == PC1_256) || (Algorithm == AES_256)
//Define decrypt key: 256b
unsigned char DecryptKey[32] ={
  0x46, 0xCC, 0x2B, 0xCA, 0x8A, 0x48, 0x1A, 0x8D,
  0xE3, 0xFA, 0x71, 0xDB, 0x9F, 0xF4, 0xEB, 0xD3,
  0xA0, 0xC0, 0xC8, 0x5A, 0x37, 0xFC, 0xDE, 0x09,
  0x3C, 0xDE, 0x10, 0x31, 0x93, 0x12, 0x98, 0x17
};

#endif

#endif

#endif

//End of file: bootcfg.h
