#include "crc.h"
#include <util/crc16.h>

uint8_t read_and_send_flash_crc(uint8_t print)
{

	uint32_t startAddr=0;
    uint32_t lastAddr=0; 
    uint32_t addr; 
    uint8_t  byte_u8; 
    uint16_t crc_u16=0; 

    /* First get the last address programmed -- this should be immediately 
     * after the interrupt vectors. 
     */ 
	 SP_WaitForSPM();
    lastAddr = SP_ReadWord( (uint32_t) 0x1f6 );
	SP_WaitForSPM();
	lastAddr = lastAddr << 16;
	lastAddr  |= SP_ReadWord( (uint32_t) 0x1f4 );
 	SP_WaitForSPM();



    if ( ( 0 == lastAddr ) || ( lastAddr > 0x03dfff ) ) 
    { 
        /* Address is incorrectly set - it's bad! */ 
		if (print == 1)
		{	
			send_char(crc_u16 & 0xFF);
			send_char((crc_u16 >> 8) & 0xFF);


			send_char(SP_ReadWord( lastAddr ) & 0xFF);
			send_char((SP_ReadWord( lastAddr ) >> 8) & 0xFF);
		}

        return( 0 ); 
    } 


	//little endiean Saved least sig  first
	//Ausgaben mit LSB First
//	send_char( startAddr & 0xFF);
//	send_char((startAddr >> 8) & 0xFF);
//	send_char((startAddr >> 16) & 0xFF);
//	send_char((startAddr >> 24) & 0xFF);


//	send_char(lastAddr & 0xFF);
//	send_char((lastAddr >> 8) & 0xFF);
//	send_char((lastAddr >> 16) & 0xFF);
//	send_char((lastAddr >> 24) & 0xFF);

    /* Compute the CRC */ 

    for( addr = startAddr; addr < lastAddr; addr++) 
    { 
        byte_u8 = SP_ReadByte( addr ); 
        crc_u16 = _crc_xmodem_update( crc_u16, byte_u8 ); 
		SP_WaitForSPM();
    } 

if (print == 1)
{	
	send_char(crc_u16 & 0xFF);
	send_char((crc_u16 >> 8) & 0xFF);


	send_char(SP_ReadWord( lastAddr ) & 0xFF);
	send_char((SP_ReadWord( lastAddr ) >> 8) & 0xFF);
}

    if( SP_ReadWord( lastAddr ) != crc_u16 ) 
    { 
        return( 0 ); /* Bad CRC */ 
    } 
    else 
    { 
        return( 1 ); /* Good CRC */ 
    } 
} 

